# version and release
%define pkgver 2010.10.26
%define pkgrel 1%{?dist}

# which lisp we are building for
%ifarch x86_64
%define cmucl_build 0
%else
%define cmucl_build 1
%endif
%define sbcl_build  1
%define clisp_build 1

# lisp versions
%if 0%{?fedora} == 14
%define cmucl_ver  20a
%define cmucl_ext  sse2f
%define clisp_ver  2.47
%define sbcl_ver   1.0.40
%define sbcl_rel   1
%endif
%if 0%{?fedora} == 13
%define cmucl_ver  20a
%define cmucl_ext  sse2f
%define clisp_ver  2.47
%define sbcl_ver   1.0.38
%define sbcl_rel   2
%endif
%if 0%{?fedora} == 12
%define cmucl_ver  19f
%define cmucl_ext  sse2f
%define clisp_ver  2.47
%define sbcl_ver   1.0.38
%define sbcl_rel   2
%endif
%if 0%{?fedora} == 11
%define cmucl_ver  19f
%define cmucl_ext  sse2f
%define clisp_ver  2.47
%define sbcl_ver   1.0.35
%define sbcl_rel   1
%endif
%if 0%{?fedora} == 10
%define cmucl_ver  19e
%define cmucl_ext  x86f
%define clisp_ver  2.47
%define sbcl_ver   1.0.30
%define sbcl_rel   1
%endif
%if 0%{?rhel} == 5
%define cmucl_ver  19d
%define cmucl_ext  x86f
%define clisp_ver  2.43
%define sbcl_ver   1.0.38
%define sbcl_rel   2
%endif

# various locations
%define cmucl_cmn_bin_dir %{_libdir}/cmucl/lib/cmn
%define cmucl_subsystems  %{_libdir}/cmucl/lib/subsystems
%define clisp_cmn_bin_dir %{_libdir}/clisp/cmn
%define clisp_subsystems  %{_libdir}/clisp/subsystems
%define sbcl_cmn_bin_dir  %{_libdir}/sbcl/cmn
%define sbcl_subsystems   %{_libdir}/sbcl/site-systems
%define cmn_src_dir       %{_datadir}/common-lisp/source/cmn

Summary: Common Music Notation (CMN %{version})
Name: cmn
Version: %{pkgver}
Release: %{pkgrel}
License: GPL
Group: Development/Languages
URL: http://www-ccrma.stanford.edu/software/cmn
Source0: %{name}.tar.gz
Source1: asdf.lisp
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Packager: Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

Obsoletes: cmn-source

%if "%{cmucl_build}" == "1"
BuildRequires: cmucl = %{cmucl_ver}
%endif
%if "%{clisp_build}" == "1"
BuildRequires: clisp = %{clisp_ver}
%endif
%if "%{sbcl_build}" == "1"
BuildRequires: sbcl = %{sbcl_ver}
%endif

%description
This package contains CMN [%{version}] (Common Music Notation) 
built on top of cmucl Common Lisp.

Common Music Notation, by Bill Schottstaedt is a Common Lisp program
that can create and display traditional western music scores.

%package cmucl
Summary: Common Music Notation binaries for CMUCL (CMN %{version})
Group: Development/Languages
Requires: cmucl = %{cmucl_ver}
Requires: cmn = %{version}-%{release}
Obsoletes: cmucl-cm-clm-cmn

%description cmucl
This package contains CMN [%{version}] (Common Music Notation) 
built on top of CMUCL Common Lisp.

%package clisp
Summary: Common Music Notation binaries for CLISP (CMN %{version})
Group: Development/Languages
Requires: clisp = %{clisp_ver}
Requires: cmn = %{version}-%{release}
Obsoletes: clisp-cm-clm-cmn

%description clisp
This package contains CMN [%{version}] (Common Music Notation) 
built on top of CLISP Common Lisp.

%package sbcl
Summary: Common Music Notation binaries for SBCL (CMN %{version})
Group: Development/Languages
Requires: sbcl >= %{sbcl_ver}-%{sbcl_rel}
Requires: cmn = %{version}-%{release}

%description sbcl
This package contains CMN [%{version}] (Common Music Notation) 
built on top of SBCL Common Lisp.

%prep
%setup -q -n cmn

%build

# SBCL
%if %{sbcl_build}
%{__mkdir} bin-sbcl
# define the sbcl cmn load program
%{__cat} <<EOF >cmn-sbcl-load.lisp
;;;
;;; SBCL Common Music Notation (CMN) startup code
;;;
(format t ";;;~%;;; Loading CMN %{version}...~%;;; (please be patient...)~%;;;~%")
(load "%{cmn_src_dir}/cmn-all.lisp")
(defun in-package-cmn()(in-package :cmn))
(format t ";;;~%;;; CMN %{version} loaded~%;;;~%")
EOF

# build cmn
/usr/bin/sbcl <<EOF
(setf *compile-print* nil)
(declaim (sb-ext:muffle-conditions style-warning sb-ext:compiler-note))
(declaim (sb-ext:muffle-conditions sb-ext:code-deletion-note))
(in-package :cl-user)
(defparameter cmn-directory "")
(defparameter cmn-bin-directory "bin-sbcl/")
(load "cmn-all.lisp")
(compile-file "cmn-sbcl-load.lisp")
(quit)
EOF
%endif

# CMUCL
%if %{cmucl_build}
%{__mkdir} bin-cmucl
# install the asdf system
%{__cp} %{SOURCE1} .
# define the cmucl cmn load program
%{__cat} <<EOF >cmn-cmucl-load.lisp
;;;
;;; CMUCL Common Music Notation (CMN) startup code
;;;
(format t ";;;~%;;; Loading CMN %{version}...~%;;; (be patient...)~%;;;~%")
(setf *compile-print* nil)
;;; load asdf
(require :asdf (make-pathname :name "asdf" :directory (pathname-directory "%{cmucl_cmn_bin_dir}/")))
;;; load cmn
(let ((ext:*gc-verbose* nil)
      (ext:*bytes-consed-between-gcs*
           (* ext:*bytes-consed-between-gcs* 5)))
  (push "%{cmn_src_dir}/" asdf:*central-registry*)
  (asdf:operate 'asdf:load-source-op :cmn))
(defun in-package-cmn()(in-package :cmn))
(format t ";;;~%;;; CMN %{version} loaded~%;;;~%")
EOF

# build cmn
/usr/bin/lisp <<EOF
(setf *compile-print* nil)
;;; we use asdf.lisp from cm
(compile-file "asdf.lisp")
(require :asdf (make-pathname :name "asdf"))
;; build cmn
(let ((ext:*gc-verbose* nil)
      (ext:*bytes-consed-between-gcs*
         (* ext:*bytes-consed-between-gcs* 5)))
   (defparameter cmn-directory "")
   (defparameter cmn-bin-directory "bin-cmucl/")
   (asdf:operate 'asdf:load-source-op :cmn))
(quit)
EOF
%endif

# CLISP
%if %{clisp_build}
%{__mkdir} bin-clisp
# install the asdf system
%{__cp} %{SOURCE1} .
# define the clisp cmn load program
%{__cat} <<EOF >cmn-clisp-load.lisp
;;;
;;; CLISP Common Music Notation (CMN) startup code
;;;
(format t ";;;~%;;; Loading CMN %{version}...~%;;; (be patient...)~%;;;~%")
;;; load asdf
(require :asdf (make-pathname :name "asdf" :directory (pathname-directory "%{clisp_cmn_bin_dir}/")))
(push "%{cmn_src_dir}/" asdf:*central-registry*)
(asdf:operate 'asdf:load-source-op :cmn)
(format t ";;;~%;;; CMN %{version} loaded~%;;;~%")
EOF

# build cmn
/usr/bin/clisp <<EOF
(setf *compile-print* nil)
(in-package :cl-user)
;;; we use asdf.lisp from cm
(compile-file "asdf.lisp")
(require :asdf (make-pathname :name "asdf"))
;; build cmn
(defparameter cmn-directory "")
(defparameter cmn-bin-directory "bin-clisp/")
(asdf:operate 'asdf:load-source-op :cmn)
(quit)
EOF
%endif

%install
%{__rm} -rf %{buildroot}

%{__mkdir} -p %{buildroot}%{_bindir}
%{__mkdir} -p %{buildroot}%{cmn_src_dir}
%{__mkdir} -p %{buildroot}%{_docdir}

# copy the cmn original source tree, this is going to be *cmn-source-directory*
# not a good idea to do this if there are patches
(cd %{buildroot}%{cmn_src_dir}; \
%{__tar} xzf %{SOURCE0}; %{__mv} cmn/* .; /bin/rmdir cmn)

# ALL installs
%if "%{sbcl_build}" == "1" || "%{cmucl_build}" == "1" || "%{clisp_build}" == "1"
# patch cmn-all.lisp with proper startup paths, this is needed so that
# cmn can be loaded with (use-system ...) from within common music,
# also add compiler message muffling
%{__perl} -p -i -e "s|\(if \(not \(boundp 'cmn-directory\)\)|\#\+\(or sbcl cmucl clisp\) \(setf \*compile-print\* nil\)\n\#\+sbcl \(declaim \(sb-ext\:muffle-conditions style-warning sb-ext:compiler-note\)\)\n\\#\+sbcl (declaim \(sb-ext\:muffle-conditions sb-ext\:code-deletion-note\)\)\n\n\(defparameter cmn-directory \"%{cmn_src_dir}/\"\)\n\(defparameter cmn-bin-directory \#\+sbcl \"%{sbcl_cmn_bin_dir}/\" \#\+cmu \"%{cmucl_cmn_bin_dir}/\" \#\+clisp \"%{clisp_cmn_bin_dir}/\"\)\n\n\(if \(not \(boundp 'cmn-directory\)\)|" %{buildroot}%{cmn_src_dir}/cmn-all.lisp

%endif

# SBCL install
%if %{sbcl_build}
%{__mkdir} -p %{buildroot}%{sbcl_cmn_bin_dir}

(cd %{_builddir}/%{name}/bin-sbcl; %{__tar} cf - *)|\
(cd %{buildroot}%{sbcl_cmn_bin_dir}; %{__tar} xpf -)

# install the load subsystem
%{__cp} -p cmn-sbcl-load.lisp %{buildroot}%{cmn_src_dir}/cmn-sbcl.lisp
%{__cp} -p cmn-sbcl-load.fasl %{buildroot}%{sbcl_cmn_bin_dir}/cmn.fasl

# the cmn startup script
%{__cat} <<EOF >%{buildroot}%{_bindir}/cmn-sbcl
#!/bin/bash
# CMN startup script for SBCL
exec /usr/bin/sbcl --load "%{sbcl_cmn_bin_dir}/cmn" --eval "(in-package-cmn)" \$@
EOF
%{__chmod} 0755 %{buildroot}%{_bindir}/cmn-sbcl
%endif

# CMUCL install
%if %{cmucl_build}
%{__mkdir} -p %{buildroot}%{cmucl_cmn_bin_dir}

(cd %{_builddir}/%{name}/bin-cmucl; %{__tar} cf - *)|\
(cd %{buildroot}%{cmucl_cmn_bin_dir}; %{__tar} xpf -)

# install asdf
%{__cp} -p asdf.lisp %{buildroot}%{cmn_src_dir}/
%{__cp} -p asdf.%{cmucl_ext} %{buildroot}%{cmucl_cmn_bin_dir}/

# install the load program
%{__cp} -p cmn-cmucl-load.lisp %{buildroot}%{cmucl_cmn_bin_dir}/cmn.lisp

# the cmn startup script
%{__cat} <<EOF >%{buildroot}%{_bindir}/cmn-cmucl
#!/bin/bash
# CMN startup script for CMUCL
exec /usr/bin/lisp -load "%{cmucl_cmn_bin_dir}/cmn.lisp" -eval "(in-package-cmn)" \$@
EOF
%{__chmod} 0755 %{buildroot}%{_bindir}/cmn-cmucl
%endif

# CLISP install
%if %{clisp_build}
%{__mkdir} -p %{buildroot}%{clisp_cmn_bin_dir}

# move all the binaries except .lib files (which confuse the clm and cmn requires)
find %{_builddir}/%{name}/bin-clisp -type f ! -name \*.lib -exec %{__mv} {} %{buildroot}%{clisp_cmn_bin_dir} \;

# install asdf
%{__cp} -p asdf.lisp %{buildroot}%{cmn_src_dir}/
%{__cp} -p asdf.fas %{buildroot}%{clisp_cmn_bin_dir}/

# install the load program
%{__cp} -p cmn-clisp-load.lisp %{buildroot}%{clisp_cmn_bin_dir}/cmn.lisp

# the cmn startup script
%{__cat} <<EOF >%{buildroot}%{_bindir}/cmn-clisp
#!/bin/bash
# CMN startup script for clisp
exec /usr/bin/clisp -I -i "%{clisp_cmn_bin_dir}/cmn.lisp" -p "CMN" \$@
EOF
%{__chmod} 0755 %{buildroot}%{_bindir}/cmn-clisp
%endif

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc
%{cmn_src_dir}

%if %{cmucl_build}
%files cmucl
%defattr(-,root,root,-)
%{cmucl_cmn_bin_dir}
%{_bindir}/*cmucl
%endif

%if %{clisp_build}
%files clisp
%defattr(-,root,root,-)
%{clisp_cmn_bin_dir}
%{_bindir}/*clisp
%endif

%if %{sbcl_build}
%files sbcl
%defattr(-,root,root,-)
%{sbcl_cmn_bin_dir}
%{_bindir}/*sbcl
%endif

%changelog
* Thu Dec  2 2010 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2010.10.26-1
- added support for fc14, updated to 2010.10.26

* Wed Jun  2 2010 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2009.10.01-2
- updated lisp versions for fc12/13

* Wed May 19 2010 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added lisp versions for fc13

* Thu Mar  4 2010 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2009.10.01-1
- udpated to latest snapshots, rebuild for sbcl 1.0.35

* Tue Nov 24 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- updated lisp versions for fc12

* Tue Sep 29 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2009.02.10-1
- updated lisp versions for CentOS 5

* Wed Sep  2 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2009.02.10-1
- updated lisp versions for Fedora 10/11, updated to latest
  cmn snapshot, make cmucl extension configurable

* Wed Jun 10 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2008.03.26-3
- updated lisp versions for Fedora 11
- cmucl changed extension from x86f to sse2f (uses vector instructions)

* Mon Dec  3 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2008.03.26-2
- updated sbcl version for Fedora 10

* Mon Dec  1 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2008.03.26-1
- updated sbcl version for Fedora 8 to 1.0.22 (same for x86_64 in fc9)

* Wed Nov 26 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2008.03.26-1
- updated to latest cmn, updated lisp versions on fc9

* Tue Nov 25 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added support for fc10, removed build support for fc < 7

* Fri Jul  4 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2008.01.09-3
- updated to new versions of sbcl and cmucl in fc8/9

* Tue May 13 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added lisp versions for f9

* Fri Feb  1 2008 Arnaud Gomes-do-Vale <Arnaud.Gomes@ircam.fr>
- built on CentOS 5

* Fri Jan 18 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2008.01.09-2
- rebuild for sbcl 1.0.13 on f7/8

* Tue Dec  4 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.10.03-1
- updated to 2007.11.03 snapshot
- rebuilt on f7/f8 for clisp 2.43

* Wed Nov 14 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.10.03-1
- updated to 2007.10.03 snapshot
- added lisp versions for f8

* Tue Sep  4 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.08.27-1
- updated to 2007.08.27 snapshot, build on sbcl 1.0.9-1

* Mon Jun 11 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.05.28-1
- updated to 2007.05.28 snapshot, build on sbcl 1.0.6

* Tue May  8 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.05.03-1
- updated to 2007.05.03 snapshot
- added fc7 support

* Mon Apr 23 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.04.15-1
- update to 2007.04.15 snapshot
- rebuild on fc5, fix quit, on clisp "(quit)" no longer needs to be
  imported into the cmn package

* Mon Apr  2 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.03.22-2
- updated to 2007.03.22 snapshot, rebuild on new sbcl 1.0.4-1.1
  (with threading enabled)
- use release aware Requires: to make sure right sbcl is used

* Wed Mar 28 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.02.21-2
- rebuild for sbcl 1.0.4

* Fri Mar 16 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2007.02.21-1
- updated to 2007.02.21 snapshot

* Thu Dec 21 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2006.12.12-1
- updated to 2006.12.12 snapshot, build on fc6/sbcl=1.0

* Wed Nov 29 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2006.10.19-1
- updated to 2006.10.19 snapshot

* Thu Nov 24 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2006.08.10-2
- rebuild for sbcl 0.9.18 and clisp 2.41 on fc5

* Thu Sep  7 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2006.08.10
- updated to 2006.08.10

* Sat Jun 24 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2006.05.07
- updated to 2006.05.07
- removed support for the xcmnw.c viewer (cmn dropped it on Mar 27 2006),
  removed associated build dependencies, do not load shared object

* Sat Dec 17 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- redo support for clisp to match sbcl and cmucl

* Tue Dec 13 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2005.11.03
- updated to 2005.11.03
- reworked sbcl build to match new common music build and startup system
- added tcsh build requirement

* Tue Aug 16 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2005.07.12
- updated to 2005.07.12
- do not build for clisp on fc4

* Sat Jan  7 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2005.01.06
- updated to 2005.01.06

* Fri Dec 24 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.12.17
- updated to 2004.12.17
- spec file cleanup
- disable style warnings in sbcl (thanks to Rick Taube)

* Mon Nov  8 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.10.29-1
- udpated to 2004.10.29 tarfile
- enabled sbcl build
- updated versions of lisps

* Wed May 19 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.05.18-1
- updated to 2004.05.18 tarfile
- try to hack around problem that happens in cmucl when -eval is used with
  code that has spaces in it

* Wed May 12 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.04.09-1
- updated to 2004.04.09 tarfile
- added buildrequires

* Mon Mar 15 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.03.08-1
- updated to 2004.03.08 tarfile

* Mon Feb  9 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2004.02.04-1
- updated to 2004.02.04

* Tue Feb  4 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2003.12.30-1
- clisp: suppress redefinition warnings during load

* Mon Feb  2 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2003.12.30-1
- updated to 2004.01.30

* Wed Jan 28 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2003.12.28-1
- updated to 2004.01.28

* Sat Jan 17 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2003.12.15-1
- initial build
- see old changelog history in the cm package spec file
